Attribute VB_Name = "modSystemSetupDialogs"
Option Explicit

Private Sub Main()
    Call MsgBox("Es wird der Dialog fr die allgemeine Systeminformation aufgerufen.")
    Call ShowDialog(0)
End Sub

Private Sub ShowDialog(ByVal DialogID As Integer, Optional ByVal Data As String)
    Dim s As String
    Select Case DialogID
        
        '*******************************************
        ' Control Panel ("control.exe").
        '*******************************************
        
        ' Systemsteuerungsordner.
        Case 0: s = "control.exe"
        
        ' Gesamte Systemsteuerung.
        Case 1: s = "rundll32.exe shell32.dll,Control_RunDLL"
        
        ' Systemsteuerung neu einrichten/einlesen?!
        Case 2: s = "rundll32.exe shell32.dll,Control_FillCache_RunDLL"
        
        '*******************************************
        ' Mouse/Keyboard/Printers/Fonts Options("main.cpl").
        '*******************************************
        
        ' Mouse Properties.
        Case 3: s = "rundll32.exe shell32.dll,Control_RunDLL main.cpl @0"
        
        ' General Keyboard Properties.
        Case 4: s = "rundll32.exe shell32.dll,Control_RunDLL main.cpl @1"
        
        ' Keyboard Language Settings.
        Case 5: s = "rundll32.exe shell32.dll,Control_RunDLL main.cpl @1,1"
        
        ' Keyboard Type.
        Case 6: s = "rundll32.exe shell32.dll,Control_RunDLL main.cpl @1,2"
        
        ' Printers.
        Case 7: s = "rundll32.exe shell32.dll,Control_RunDLL main.cpl @2"
        
        ' Fonts.
        Case 8: s = "rundll32.exe shell32.dll,Control_RunDLL main.cpl @3"
        
        ' Energy (Battery Settings).
        Case 9: s = "rundll32.exe shell32.dll,Control_RunDLL main.cpl @4"
        
        '*******************************************
        ' Network ("ncpa.cpl").
        '*******************************************
        
        ' Add a new Connection.
        Case 10: s = "rundll32.exe shell32.dll,Control_RunDLL ncpa.cpl,,1"
        
        ' Network Connections.
        Case 11: s = "rundll32.exe shell32.dll,Control_RunDLL ncpa.cpl,@0,2"
        
        '*******************************************
        ' Date and Time Options ("timedate.cpl").
        '*******************************************
        
        ' Date and Time.
        ' "rundll32.exe shell32.dll,Control_RunDLL timedate.cpl,@0,0"
        Case 12: s = "rundll32.exe shell32.dll,Control_RunDLL timedate.cpl"
        
        ' Timezone Information.
        Case 13: s = "rundll32.exe shell32.dll,Control_RunDLL timedate.cpl,,1"
        
        '*******************************************
        ' Microsoft Mail Postoffice Options ("wgpocpl.cpl").
        '*******************************************
        
        ' Microsoft Workgroup Postoffice Admin.
        Case 14: s = "rundll32.exe shell32.dll,Control_RunDLL wgpocpl.cpl"
        
        '*******************************************
        ' Accessability Options ("access.cpl").
        '*******************************************
        
        ' Accessability Properties (Keyboard).
        Case 15: s = "rundll32.exe shell32.dll,Control_RunDLL access.cpl,,1"
        
        ' Accessability Properties (Sound).
        Case 16: s = "rundll32.exe shell32.dll,Control_RunDLL access.cpl,,2"
        
        ' Accessability Properties (Display).
        Case 17: s = "rundll32.exe shell32.dll,Control_RunDLL access.cpl,,3"
        
        ' Accessability Properties (Mouse).
        Case 18: s = "rundll32.exe shell32.dll,Control_RunDLL access.cpl,,4"
        
        ' Accessability Properties (General).
        Case 19: s = "rundll32.exe shell32.dll,Control_RunDLL access.cpl,,5"
        
        '*******************************************
        ' Display Options("desk.cpl").
        '*******************************************
        
        ' Display Properties (Background).
        Case 20: s = "rundll32.exe shell32.dll,Control_RunDLL desk.cpl,,0"
        
        ' Display Properties (Screen Saver).
        ' "rundll32.exe shell32.dll,Control_RunDLL desk.cpl,@0,1"
        Case 21: s = "rundll32.exe shell32.dll,Control_RunDLL desk.cpl,,1"
        
        ' Display Properties (Appearance).
        Case 22: s = "rundll32.exe shell32.dll,Control_RunDLL desk.cpl,,2"
        
        ' Display Properties (Settings).
        Case 23: s = "rundll32.exe shell32.dll,Control_RunDLL desk.cpl,,3"
        
        '*******************************************
        ' Joystick Options("joy.cpl").
        '*******************************************
        
        ' Joystick Properties (Joystick).
        Case 24: s = "rundll32.exe shell32.dll,Control_RunDLL joy.cpl"
        
        '*******************************************
        ' Mail and Fax Options("mlcfg32.cpl").
        '*******************************************
        
        ' Microsoft Exchange Profiles (General).
        Case 25: s = "rundll32.exe shell32.dll,Control_RunDLL mlcfg32.cpl"
        
        '*******************************************
        ' Modem Options("modem.cpl").
        '*******************************************
        
        ' Modem Properties (General).
        Case 26: s = "rundll32.exe shell32.dll,Control_RunDLL modem.cpl"
        
        ' Add a Modem.
        Case 27: s = "rundll32.exe shell32.dll,Control_RunDLL modem.cpl,,add"
        
        '*******************************************
        ' Network Options("netcpl.cpl").
        '*******************************************
        
        ' Network (Configuration).
        Case 28: s = "rundll32.exe shell32.dll,Control_RunDLL netcpl.cpl"
        
        '*******************************************
        ' Password Options("password.cpl").
        '*******************************************
        
        ' Password Properties (Change Passwords).
        Case 29: s = "rundll32.exe shell32.dll,Control_RunDLL password.cpl"
        
        ' Password Properties.
        Case 30: s = "rundll32.exe shell32.dll,Control_RunDLL password.cpl,,0"
        
        '*******************************************
        ' Add/Remove Programs("appwiz.cpl").
        '*******************************************
        
        ' Install/Uninstall Software.
        Case 31: s = "rundll32.exe shell32.dll,Control_RunDLL appwiz.cpl"
        
        ' Add/Remove Programs Properties (Install/Uninstall).
        Case 32: s = "rundll32.exe shell32.dll,Control_RunDLL appwiz.cpl,,1"
        
        ' Add/Remove Programs Properties (Windows Setup).
        Case 33: s = "rundll32.exe shell32.dll,Control_RunDLL appwiz.cpl,,2"
        
        ' Add/Remove Programs Properties (Startup Disk).
        Case 34: s = "rundll32.exe shell32.dll,Control_RunDLL appwiz.cpl,,3"
        
        '*******************************************
        ' Regional Settings("intl.cpl").
        '*******************************************
        
        ' Regional Settings Properties (Regional Settings).
        Case 35: s = "rundll32.exe shell32.dll,Control_RunDLL intl.cpl,,0"
        
        ' Regional Settings Properties (Number).
        Case 36: s = "rundll32.exe shell32.dll,Control_RunDLL intl.cpl,,1"
        
        ' Regional Settings Properties (Currency).
        Case 37: s = "rundll32.exe shell32.dll,Control_RunDLL intl.cpl,,2"
        
        ' Regional Settings Properties (Time).
        Case 38: s = "rundll32.exe shell32.dll,Control_RunDLL intl.cpl,,3"
        
        ' Regional Settings Properties (Date).
        Case 39: s = "rundll32.exe shell32.dll,Control_RunDLL intl.cpl,,4"
        
        '*******************************************
        ' Multimedia/Sounds Options("mmsys.cpl").
        '*******************************************
        
        ' Multimedia Properties (Audio).
        ' "rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl"
        Case 40: s = "rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,0"
        
        ' Multimedia Properties (Video).
        Case 41: s = "rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,1"
        
        ' Multimedia Properties (MIDI).
        Case 42: s = "rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,2"
        
        ' Multimedia Properties (CD Music).
        Case 43: s = "rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,3"
        
        ' Multimedia Properties (Advanced).
        Case 44: s = "rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl,,4"
        
        ' Sounds Properties (System Sounds).
        Case 45: s = "rundll32.exe shell32.dll,Control_RunDLL mmsys.cpl @1"
        
        '*******************************************
        ' System/Add New Hardware Options("sysdm.cpl").
        '*******************************************
        
        ' System Properties (General).
        Case 46: s = "rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl,,0"
        
        ' System Properties (Device Manager).
        Case 47: s = "rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl,,1"
        
        ' System Properties (Hardware Profiles).
        Case 48: s = "rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl,,2"
        
        ' System Properties (Performance).
        Case 49: s = "rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl,,3"
        
        ' Add New Hardware Wizard.
        Case 50: s = "rundll32.exe shell32.dll,Control_RunDLL sysdm.cpl @1"
        
        '*******************************************
        ' Internet (Explorer) Options ("inetcpl.cpl").
        '*******************************************
        
        ' Internet Explorer Properties.
        ' "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl"
        Case 51: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,0"
        
        ' Security.
        Case 52: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,1"
        
        ' Content.
        Case 53: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,2"
        
        ' Connection.
        Case 54: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,3"
        
        ' Programs.
        Case 55: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,4"
        
        ' Advanced Options.
        Case 56: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl,,5"
        
        ' User Manager.
        Case 57: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl @1"
        
        ' User Options (General?).
        Case 58: s = "rundll32.exe shell32.dll,Control_RunDLL inetcpl.cpl users"
        
        '*******************************************
        ' System Wizards.
        '*******************************************
        
        ' Open With (File Associations).
        ' Data specifies the file which should be opened.
        Case 59: s = "rundll32.exe shell32.dll,OpenAs_RunDLL " & Data
        
        ' Run Diskcopy Dialog.
        Case 60: s = "rundll32.exe diskcopy.dll,DiskCopyRunDll"
        
        ' Format Disk.
        Case 61: s = "rundll32.exe shell32.dll,SHFormatDrive"
        
        ' Create New Shortcut Wizard.
        
        ' Puts the new shortcut in the location specified by Data.
        ' Data must contain the destination path, for example "C:\".
        Case 62: s = "rundll32.exe appwiz.cpl,NewLinkHere " & Data
        
        ' Install New Hardware Wizard.
        Case 63: s = "rundll32.exe sysdm.cpl,InstallDevice_RunDLL"
        
        ' Add Printer Wizard.
        Case 64: s = "rundll32.exe shell32.dll,SHHelpShortcuts_RunDLL AddPrinter"
        
        ' Dial-up Networking (DUN) Wizard.
        Case 65: s = "rundll32.exe rnaui.dll,RnaWizard"
        
        ' Open a Scrap Document.
        Case 66: s = "rundll32.exe shscrap.dll,OpenScrap_RunDLL /r /x %1"
        
        ' Create a Briefcase.
        Case 67: s = "rundll32.exe syncui.dll,Briefcase_Create"
        
        ' View Printers.
        Case 68: s = "rundll32.exe shell32.dll,SHHelpShortcuts_RunDLL PrintersFolder"
        
        ' View Fonts.
        Case 69: s = "rundll32.exe shell32.dll,SHHelpShortcuts_RunDLL FontsFolder"
        
        ' Pick a Time Zone Dialog.
        Case 70: s = "rundll32.exe shell32.dll,Control_RunDLL timedate.cpl,,/f"
        
        ' Print a HTML file.
        ' Data must contain the file name of the file that should be printed.
        Case 71: s = "rundll32.exe mshtml.dll,PrintHTML " & Data
        
        ' Print a test Page.
        Case 72: s = "rundll32.exe shell32.dll,SHHelpShortcuts_RunDLL PrintTestPage %1"
        
        ' Add a Printer.
        Case 73: s = "rundll32.exe shell32.dll,SHHelpShortcuts_RunDLL AddPrinter"
        
        ' Swap Mouse Buttons.
        ' "rundll32.exe user.exe,SwapMouseButton" (Windows 9x).
        Case 74: s = "rundll32.exe user32.dll,SwapMouseButton"    ' Win NT/2000.
        
        ' Shutdown Windows.
        Case 75: s = "rundll32.exe user,ExitWindows"
        
        ' Start an Application.
        ' Data must contain the path/file name of the application.
        ' It can also contain a URL, for example "http://www.microsoft.com".
        Case 76: s = "rundll32.exe url.dll,FileProtocolHandler " & Data
        
        ' Visit a Newsgroup.
        ' Data contains the name of the Newsgroup, for example "microsoft.public.de.vb".
        Case 77: s = "rundll32.exe url.dll,NewsProtocolHandler " & Data
        
        ' Send Mail with common Mail Program.
        ' Data contains Mail Address, for example "nomame@example.org".
        Case 78: s = "rundll32.exe url.dll,MailToProtocolHandler " & Data
        
        ' Install Screen Saver.
        ' Data must contain the file name of a valid screen saver (.scr).
        Case 79: s = "rundll32.exe desk.cpl,InstallScreenSaver " & Data
        
        ' RNA Conntection Wizard.
        Case 80: s = "rundll32.exe rnaui.dll,RnaWizard @1"
        
        ' Existing RNA Connection.
        ' Data must contain the name of an existing connection.
        Case 81: s = "rundll32.exe rnaui.dll,RnaDial " & Data
    End Select
    Call Shell(s, vbNormalFocus)
End Sub
